/*
 * SynRPCClientProxy.h
 *
 *  Created on: Jun 10, 2011
 *      Author: root
 */

#ifndef SYNRPCCLIENTPROXY_H_
#define SYNRPCCLIENTPROXY_H_

#include <string>
#include <asio.hpp>
#include "casock/util/Lock.h"
#include "casock/rpc/protobuf/api/rpc.pb.h"
#include "casock/rpc/protobuf/client/RPCRequestBuilder.h"
#include "casock/rpc/protobuf/client/RPCCallController.h"
#include "casock/util/TimeoutConfigurable.h"
#include <google/protobuf/service.h>

namespace casock {

namespace rpc {

namespace synio {

namespace protobuf {

namespace client {
using namespace std;
using namespace casock::rpc::protobuf::api;
using namespace casock::rpc::protobuf::client;

	class SynRPCClientProxy : public ::google::protobuf::RpcChannel, public casock::util::TimeoutConfigurable
	{
		public:
			SynRPCClientProxy(const std::string& ip, const int& port);
			virtual ~SynRPCClientProxy();
        private:

        public:
            /*!
             * Overridden from ::google::protobuf::RpcChannel
             *
             * Called by google protobuf framework when some user defined
             * RPC service method is called.
             */
			void CallMethod (
			            const google::protobuf::MethodDescriptor* method,
			            google::protobuf::RpcController* controller,
			            const google::protobuf::Message* request,
			            google::protobuf::Message* response,
			            google::protobuf::Closure* done);
			void close ();
			virtual RPCCallController* buildRPCCallController () const;
        protected:
          void init();
          void sendRpcRequest(const google::protobuf::Message* request);
          void resvRpcResponse( google::protobuf::Message* rpsponse);
          bool isBroken();

        private:
          string mIp;
          int mPort;
          int mSocketFd;
          bool initSuccess;
          ::casock::util::Lock lock;
          static const RPCRequestBuilder* smpRequestBuilder;
	};

}

}

}

}

}

#endif /* SYNRPCCLIENTPROXY_H_ */
