
#include "casock/util/Logger.h"
#include <casock/util/Exception.h>
#include "casock/rpc/protobuf/client/RPCCallController.h"
#include "casock/rpc/synio/protobuf/client/SynRPCClientProxy.h"

#include "casock/rpc/protobuf/client/RPCResponseHandler.h"
#include "examples/rpc/protobuf/api/rpc_hello.pb.h"
using namespace std;
class casock::rpc::synio::protobuf::client::SynRPCClientProxy;

casock::rpc::synio::protobuf::client::SynRPCClientProxy* proxy;
HelloService* service;
HelloRequest request;
HelloRequest request2;

class HelloHandler : public casock::rpc::protobuf::client::RPCResponseHandler
{
  public:
    HelloHandler (HelloResponse* pResponse)
      //: casock::rpc::protobuf::client::RPCResponseHandler (pController), mpResponse (pResponse)
      :  mpResponse (pResponse)
    { }

  public:
    void callback ()
    {
      LOGMSG (NO_DEBUG, "HelloHandler::%s ()\n", __FUNCTION__);

      if ( mpResponse->id () < 2)
      {
        LOGMSG (NO_DEBUG, "HelloHandler::%s () - message [%s]\n", __FUNCTION__, mpResponse->message ().c_str ());

      }
      else
      {
        LOGMSG (NO_DEBUG, "HelloHandler::%s () - message [%s]\n", __FUNCTION__, mpResponse->message ().c_str ());

      }

      //delete mpResponse;
    }

  private:
    HelloResponse* mpResponse;
};

int main ()
{
  //LOGGER->setDebugLevel (SILENT);
	LOGGER->setDebugLevel (DISABLE);
  LOGMSG (LOW_LEVEL, "%s () - start\n", __FUNCTION__);
  int iCount=0;
while(1) {
    HelloResponse* response = new HelloResponse ();
    HelloResponse* response2 = new HelloResponse ();
  try
  {
    proxy = new casock::rpc::synio::protobuf::client::SynRPCClientProxy(string("127.0.0.1"),2000);

    service = new HelloService::Stub (proxy);


    request.set_id (1);
    request.set_message ("Hello!");

    request2.set_id (2);
    request2.set_message ("Hello again!");

    HelloHandler handler ( response);
    HelloHandler handler2 (response2);
    LOGMSG (NO_DEBUG, "%s () - service->HelloCall (...)\n", __FUNCTION__);

    try
    {
      service->HelloCall (NULL, &request, response, handler.closure ());
      delete service;
      service = new HelloService::Stub (proxy);
      service->HelloCall (NULL, &request2, response2, NULL);
      handler2.callback();
    }
    catch (std::exception& e)
    {
      LOGMSG (NO_DEBUG, "%s () - exception: [%s]\n", __FUNCTION__, e.what ());
      exit(1);
    }
  }
  catch (...)
  {
    LOGMSG (NO_DEBUG, "%s () - catch (...)\n", __FUNCTION__);
    exit(2);
  }

  delete response;
  delete response2;
  delete service;
  delete proxy;
  //casock::proactor::asio::base::AsyncProcessor::destroy ();
  LOGMSG (NO_DEBUG, "%s () - finished count=[%d]\n", __FUNCTION__, ++iCount);
  usleep(1000);
}

}

